/*
 * Work under Copyright. Licensed under the EUPL.
 * See the project README.md and LICENSE.txt for more information.
 */

package net.dries007.tfc.objects.blocks.wood;

import java.util.EnumMap;
import java.util.Random;

import net.minecraft.block.BlockDoor;
import net.minecraft.block.SoundType;
import net.minecraft.block.material.Material;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.init.Blocks;
import net.minecraft.init.Items;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.util.math.BlockPos;
import net.minecraft.util.math.RayTraceResult;
import net.minecraft.world.World;

import net.dries007.tfc.objects.Wood;
import net.dries007.tfc.objects.items.wood.ItemDoorTFC;

public class BlockDoorTFC extends BlockDoor
{
    private static final EnumMap<Wood, BlockDoorTFC> MAP = new EnumMap<>(Wood.class);

    public static BlockDoorTFC get(Wood wood)
    {
        return MAP.get(wood);
    }

    public final Wood wood;

    public BlockDoorTFC(Wood wood)
    {
        super(Material.field_151575_d);
        if (MAP.put(wood, this) != null) throw new IllegalStateException("There can only be one.");
        this.wood = wood;
        func_149672_a(SoundType.field_185848_a);
        func_149711_c(3.0F);
        func_149649_H();
        // No direct item, so no oredict.
        Blocks.field_150480_ab.func_180686_a(this, 5, 20);
    }

    public Item getItem()
    {
        return ItemDoorTFC.get(wood);
    }

    @Override
    public Item func_180660_a(IBlockState state, Random rand, int fortune)
    {
        return state.func_177229_b(field_176523_O) == BlockDoor.EnumDoorHalf.UPPER ? Items.field_190931_a : getItem();
    }

    @Override
    public ItemStack getPickBlock(IBlockState state, RayTraceResult target, World world, BlockPos pos, EntityPlayer player)
    {
        return new ItemStack(getItem());
    }
}
